<?php
/**
 *  This file is part of amfPHP
 *
 * LICENSE
 *
 * This source file is subject to the license that is bundled
 * with this package in the file license.txt.
 * @package Amfphp_Services
 */


/**
 * This is a test/example service. Remove it for production use
 *
 * @package Amfphp_Services
 * @author Ariel Sommeria-klein
 */
class AfterburnerService
{
	
	private $oSqlConnection;
	
		// ---------------------------------------- __construct() ----------------------------------------------------
	/**
	 * @brief Constructeur de la classe. Initialise les proprietes.
	 *
	 */
	public function __construct()
	{
		// ajout des classes php
		require_once("../php/Mysql.php");

		// connection  la base de donnes mysql
		$this->oSqlConnection = new Mysql();
	}
	

	/**
	 * Sauvegarde le score dans la base de donnes.
	 * @param le numro de la page
	 * @param le nombre de rsultat dans la page
	 * @return .
	 *
	 */
	public function addScore($sNamePlayer, $nScore)
	{
		//on enregistre l adresse ip si elle est inconnu et on incremente le compteur
		$s_sqlInsert = "INSERT INTO `afterburner`(
			`id` ,
			`name` ,
			`date` ,
			`score`
		)
		VALUES (
			NULL ,  '$sNamePlayer', NOW( ) ,  '$nScore'
		);";
		$o_sqlResult = $this->oSqlConnection->query($s_sqlInsert);
	}
	
	
	/**
	 * Rcupre les meilleurs score du jeu.
	 * @param le numro de la page
	 * @param le nombre de rsultat dans la page
	 * @return un tableau contenant des objets Score.
	 *
	 */
	public function getAllScore($nNumPage, $nTotal)
	{
		$aResultScore = array();
				
		$aResultScore["players"] = array();
		
		$s_sqlSelect = "SELECT name, date, score FROM afterburner ORDER BY score DESC LIMIT ".$nNumPage.",".$nTotal;
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		//$o_result = $this->oSqlConnection->getObject($o_sqlResult);
		
		$iCptPlayer = $nNumPage * $nTotal;
		while ( $o_result = $this->oSqlConnection->getObject($o_sqlResult) )
		{
			$iCptPlayer++;
			$aOnePlayer = array();
			
			$aOnePlayer["number"] = $iCptPlayer;
			$aOnePlayer["name"] = $o_result->name;
			$s_date = $o_result->date;
			$a_date_fr = $this->getDateFr($s_date, NULL, 1);
			$aOnePlayer["date"] = utf8_encode($a_date_fr["date"]." / ".$a_date_fr["time"]);
			
			$aOnePlayer["score"] = $o_result->score;
			
			$aResultScore["players"][$iCptPlayer-1] = $aOnePlayer;
		}
		
		return $aResultScore;
	}
	
		// ---------------------------------------- getDateFr() ----------------------------------------------------	
	/**			
		formats of the date :
			$i_format = 1		: 01 Janvier 2006
			$i_format = 2		: 01-01-2006
			$i_format = 3		: Janvier 2006
			$i_format = 4		: 2006
			$i_format = 7		: 01/01/2006
			$i_format = NULL	: 01-01-2006
			
		formats of the hour :
			$i_time = NULL		: H:i:s
			$i_time = 1			: Hhi (10h12)

	 * @brief Convert DATETIME MySQL in fr.
	 * @param (string) DATETIME MYSQL.
	 * @param (integer)	date format.
	 * @param (integer)	hour format.
	 * @return (array) array. $a_convertDate["date"] = $s_date; -- $a_convertDate["time"] = $i_time;
	 */
	private function getDateFr($s_dateTime, $i_format, $i_time=-1) 
	{
		$a_convertDate = array();
		$month="";
		$s_date = "";
		
		$s_year	 		= substr($s_dateTime,0,4);
		$s_month_given	= substr($s_dateTime,5,2);
		$s_day_given	= substr($s_dateTime,8,2);
	
		if ($i_format == 1 or $i_format == 3)
		{
			switch($s_month_given)
			{
				 case "01" : 
				 			$month="Janvier";
							break;
				 case "02" : 
				 			$month="Fvrier";
							break;
				 case "03" : 
				 			$month="Mars";
							break;
				 case "04" : 
				 			$month="Avril";
							break;
				 case "05" : 
				 			$month="Mai";
							break;
				 case "06" : 
							$month="Juin";
							break;
				 case "07" : 
				 			$month="Juillet";
							break;
				 case "08" : 
				 			$month="Aot";
							break;
				 case "09" : 
				 			$month="Septembre";
							break;
				 case "10" : 
				 			$month="Octobre";
							break;
				 case "11" : 
							$month="Novembre";
							break;
				 case "12" : 
				 			$month="Dcembre";
							break;
			}
			
			if ($i_format == 1) $s_date = "$s_day_given $month $s_year";
			if ($i_format == 3) $s_date = $month." ".$s_year;
		}
	
	   if ($i_format == 2)   $s_date = $s_day_given."-".$s_month_given."-".$s_year;
		
	   if ($i_format == 4)   $s_date = $s_year;
		
	   /* date in number */
	   if ($i_format == "7")   {$s_date = $s_day_given."/".$s_month_given."/".$s_year;}
	   if ($i_format == "")    {$s_date = $s_day_given."-".$s_month_given."-".$s_year;}
	
		$a_convertDate["date"] = $s_date;
		
		/* give the hours */
		$s_heure = substr($s_dateTime,11,2);
		$s_minute = substr($s_dateTime,14,2);
		$s_seconde = substr($s_dateTime,17,2);
		
		if( $i_time==1 )
			$a_convertDate["time"] = $s_heure."h".$s_minute; // Hhi
		else
			$a_convertDate["time"] = substr($s_dateTime,11,8); // H:i:s
		
		return $a_convertDate;
	   
	}
}
?>
