package afterburner.model
{

	import afterburner.event.EventList;
	
	
	import net.pixlib.events.PXObjectEvent;
	import net.pixlib.events.PXStringEvent;
	import net.pixlib.load.PXGraphicLoader;
	import net.pixlib.quick.PXQuick;
	import net.pixlib.load.collection.PXLoaderCollectionEvent;
	import net.pixlib.load.PXLoaderContext;
	import net.pixlib.load.collection.PXQueueLoader;
	import net.pixlib.model.PXAbstractModel;
	import net.pixlib.plugin.PXPlugin;
	import net.pixlib.load.PXXMLLoader;	
	
	
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.display.DisplayObjectContainer;

	

	public class AppliModel extends PXAbstractModel
	{
		public static const onAssetsLoadComplete : String = new String("onAssetsLoadComplete");
		public static const onAssetsLoadProgress : String = new String("onAssetsLoadProgress");
		

		private var container : DisplayObjectContainer;


		public function AppliModel(owner : PXPlugin = null, target : DisplayObjectContainer = null)
		{
			super(owner, ModelList.APPLI);

			container = target;
		}


		/**
		 * Chargement des éléments graphiques.
		 * Appel par la Commande StartApplication.
		 * 
		 */
		public function init() : void
		{
			var loader : PXQueueLoader = new PXQueueLoader();
			//loader.bypassError = false;
			
			loader.add( new PXGraphicLoader(), "BackgroundAnim",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/textures/background.jpg"),
			PXLoaderContext.getInstance() );	
			
			
			loader.add( new PXGraphicLoader(), "CloudAnim",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/textures/cloud.png"),
			PXLoaderContext.getInstance() );
			
			
			loader.add( new PXGraphicLoader() , "ActionsAnim",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/textures/ActionTexture.png"),
			PXLoaderContext.getInstance() );
			
			
			loader.add( new PXGraphicLoader(), "OnkyFontChars",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/fonts/onky_0.png"),
			PXLoaderContext.getInstance() );	
			
			
			loader.add( new PXGraphicLoader(), "RacerFontChars",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/fonts/racer_0.png"),
			PXLoaderContext.getInstance() );	
			
			
			loader.add( new PXGraphicLoader(), "ButttonNormal",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/images/button.png"),
			PXLoaderContext.getInstance() );	
			
			
			loader.add( new PXGraphicLoader(), "ButtonDown",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/images/button_down.png"),
			PXLoaderContext.getInstance() );	
			
			
			loader.add( new PXXMLLoader(), "SpriteSheetXmlBackground",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/textures/background.xml"),
			PXLoaderContext.getInstance() );
			
			
			loader.add( new PXXMLLoader(), "SpriteSheetXmlCloud",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/textures/cloud.xml"),
			PXLoaderContext.getInstance() );
			
			
			loader.add( new PXXMLLoader(), "ActionsXML",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/textures/action.xml"),
			PXLoaderContext.getInstance() );
			
			
			loader.add( new PXXMLLoader(), "OnkyFontXML",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/fonts/onky.fnt"),
			PXLoaderContext.getInstance() );
			
			
			loader.add( new PXXMLLoader(), "RacerFontXML",
			new URLRequest("http://www.actionscript-facile.com/ressources/assets/src-afterburner/fonts/racer.fnt"),
			PXLoaderContext.getInstance() );
			
			
			loader.addEventListener(PXLoaderCollectionEvent.onLoadInitEVENT, _onQueueLoaded);
			loader.addEventListener(PXLoaderCollectionEvent.onItemLoadProgressEVENT, _onItemLoadProgress);

			loader.load();	
			
			PXQuick.debug("init loader start");
		}

		
		/**
		 * Progression du chargements des éléments.
		 * 
		 */
		private function _onItemLoadProgress(event : PXLoaderCollectionEvent) : void
		{
			//PXQuick.debug("_onItemLoadProgress : "+event.currentLoader.percentLoaded, this);
			
			var sValue:String = "Progression du chargement...\n" +
			"Elément "+event.currentLoader.name+" : "+event.currentLoader.percentLoaded+"%";
			
			notifyChanged( new PXStringEvent(AppliModel.onAssetsLoadProgress, null, sValue) );
		}
	
		
		/**
		 * La pile des éléments est chargée.
		 * 
		 */
		private function _onQueueLoaded(event : PXLoaderCollectionEvent) : void
		{
			//PXQuick.debug("_onQueueLoaded complete", this);

			notifyChanged( new Event(AppliModel.onAssetsLoadComplete) );
			notifyChanged( new PXStringEvent(AppliModel.onAssetsLoadProgress, null, "") );
			SoundModel( PXQuick.getModel(ModelList.SOUND) ).playBackground();	
			
			// récupère le score de la base de données par remoting
			var oData:Object = new Object();
			oData.page_number = 0;
			oData.total_record = 6;
			firePrivateEvent(new PXObjectEvent(EventList.getScoreEvent, null, oData));
		}
		

	

	}
}