/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.engine
{
	import afterburner.view.ViewList;
	import afterburner.view.game.stage3D.Avion;
	import afterburner.view.game.stage3D.Background;
	import afterburner.view.game.stage3D.Cloud;
	import afterburner.view.game.stage3D.EnnemisManager;
	import afterburner.view.game.stage3D.ExplosionManager;
	import afterburner.view.game.stage3D.Interface3D;
	import afterburner.view.game.stage3D.RocketManager;
	import afterburner.view.util.Assets;
	import afterburner.view.util.BitmapDataCacher;
	import net.pixlib.quick.PXQuick;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	
	
	

	/**
	 * Utilisation du Framework 2D Starling.
	 * Moteur du jeu utilisant la puissance du GPU Stage3D.
	 * 
	 */
	public class GameDisplay3D extends starling.display.Sprite
	{

		public function GameDisplay3D()
		{
			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}


		/**
		 * Stage3D prêt.
		 * 
		 */
		private function onAdded(e : Event) : void
		{	
			PXQuick.debug("GameEngine onAdded !");
			
			/* création des Sprite Stage3D */			
			var oDisplayEnnemis:Sprite = new Sprite();
			var oDisplayRocket:Sprite = new Sprite();
			var oDisplayExplosion:Sprite = new Sprite();
			var oContentBackground:Sprite = new Sprite();
			var oContentAvion:Sprite = new Sprite();
			var oContentCloud:Sprite = new Sprite();
			var oContentInterface:Sprite = new Sprite();
			
			/* ajout des vues dans l'ordre d'affichage...  */
			addChild(oContentBackground);
			addChild(oDisplayEnnemis);
			addChild(oDisplayRocket);
			addChild(oContentAvion);
			addChild(oDisplayExplosion);
			addChild(oContentCloud);
			addChild(oContentInterface);
			
			
			/* création de la Texture du jeu */
			var texture:Texture = Assets.getInstance().getTexture("ActionsAnim");
			var xml : XML = Assets.getInstance().getDataXml("ActionsXML");
			var sTextureAtlas : TextureAtlas = new TextureAtlas(texture, xml);
			
			// mets en cache le Bitmap pour les tests de collisions
			BitmapDataCacher.cacheBitmap(ViewList.STAGE_3D, Assets.getInstance().getBitmap("ActionsAnim"), xml );
			
			
			/* création des managers */
			EnnemisManager(PXQuick.getView(ViewList.STAGE_3D_ENNEMIS) ).setDisplay3D(oDisplayEnnemis, sTextureAtlas);
			RocketManager(PXQuick.getView(ViewList.STAGE_3D_ROCKETS) ).setDisplay3D(oDisplayRocket, sTextureAtlas);
			ExplosionManager(PXQuick.getView(ViewList.STAGE_3D_EXPLOSIONS) ).setDisplay3D(oDisplayExplosion, sTextureAtlas);
			
			
			/* création des vues Stage3D */			
			Background(PXQuick.getView(ViewList.STAGE_3D_BACKGROUND) ).setDisplay3D(oContentBackground);
			Avion(PXQuick.getView(ViewList.STAGE_3D_AVION) ).setDisplay3D(oContentAvion, sTextureAtlas);
			Cloud(PXQuick.getView(ViewList.STAGE_3D_CLOUD) ).setDisplay3D(oContentCloud);
			
			Interface3D(PXQuick.getView(ViewList.STAGE_3D_INTERFACE) ).setDisplay3D(oContentInterface);

			return;
		}

		
	}
}