/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.stage3D
{

	import afterburner.view.ViewList;
	import afterburner.view.game.engine.elements.Explosion;
	import flash.display.DisplayObject;
	import net.pixlib.events.PXObjectEvent;
	import net.pixlib.plugin.PXPlugin;
	import net.pixlib.view.PXContainerView;
	import starling.display.DisplayObjectContainer;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	
	

	
	

	

	/**
	 * Utilisation du Framework 2D Starling.
	 * 
	 */
	public class ExplosionManager extends PXContainerView
	{
		private var aExplosion:Vector.<Explosion>;// contient une référence de tous les ennemis.
		
		private var oDisplay: DisplayObjectContainer;// le contenu Stage3D	

		private var vFramesVaisseau : Vector.<Texture>;// les textures des ennemis
		private var vFramesExplosion : Vector.<Texture>;

				
		public function ExplosionManager(owner : PXPlugin = null, mc : DisplayObject = null)
		{
			super(owner, ViewList.STAGE_3D_EXPLOSIONS, mc);
		}


		/**
		 * Methode appelez après l'instanciation d'une abstractUI
		 */
		override protected function onInitView() : void
		{
			hide();
		}
		
		
		public function setDisplay3D(display:DisplayObjectContainer, sTextureAtlas : TextureAtlas) : void
		{
			oDisplay = display;
			aExplosion = new Vector.<Explosion>();
			
			// ajout d'une texture			
			vFramesVaisseau = sTextureAtlas.getTextures("shipDebris");
			vFramesExplosion = sTextureAtlas.getTextures("Explosion_Sequence");
		}


		/**
		 * Ajoute une explosion sur le jeu.
		 * 
		 */
		public function addExplosion(x:Number, y:Number) : void
		{
			var oExplosion:Explosion = new Explosion(vFramesVaisseau, vFramesExplosion, x, y);
			oDisplay.addChild(oExplosion.clip);	
			aExplosion.push(oExplosion);
		}
		
		
		/**
		 * Appel par un évènement CollisionModel.
		 * 
		 */
		public function onHitEnnemiLazer(event : PXObjectEvent) : void
		{
			//logger.debug(" explosion manager onHitEnnemiRocket : "+event.value, this);

			this.addExplosion( event.value.x as Number, event.value.y as Number);
		}	
		
		
		/**
		 * Appel par un évènement CollisionModel.
		 * 
		 */
		public function onHitEnnemiRocket(event : PXObjectEvent) : void
		{
			//logger.debug(" explosion manager onHitEnnemiRocket : "+event.value, this);

			this.addExplosion( event.value.x as Number, event.value.y as Number);
		}			
			
		
		/**
		 * Appel par un évènement CollisionModel.
		 * 
		 */
		public function onHitEnnemiAvion(event : PXObjectEvent) : void
		{
			//logger.debug(" explosion manager onHitEnnemiRocket : "+event.value, this);

			this.addExplosion( event.value.x as Number, event.value.y as Number);
		}	
		

		/**
		 * Appel par une commande.
		 * 
		 */
		public function onStopGame() : void
		{
			var oExplosion:Explosion;
			// supprime toutes les explosions à l'écran
			for (var i : int = 0; i < aExplosion.length; i++) 
			{
				oExplosion = aExplosion[i];
				oExplosion.dispose();	
			}
			
			aExplosion = new Vector.<Explosion>();
		}
		
				
		/**
		 * Mise à jour toutes les images pour effectuer le défilement du décor.
		 * 
		 */
		public function update() : void
		{
			var oExplosion:Explosion;
			
			for (var i : int = 0; i < aExplosion.length; i++) 
			{
				oExplosion = aExplosion[i];
				oExplosion.update();
			
				// si l'explosion n'est plus visible
				if( oExplosion.clip.visible == false )
				{
					aExplosion.splice(i, 1);// enlève l'ennemi du tableau
					oExplosion.dispose();	
				}
			}
			
		}
		
		
	}
}