/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.pixlib.key 
{

	/**
	 * PXKey defines constants to use for PXKeyShortcut definition.
	 * 
	 * @see PXKeyShorcut
	 * 
	 * @author Romain Ecarnot
	 */
	public class PXKey 
	{
		//--------------------------------------------------------------------
		// Constants
		//--------------------------------------------------------------------

		public static const A : PXKeyShortcut = PXKeyShortcut.buildShortcut("a");
		public static const B : PXKeyShortcut = PXKeyShortcut.buildShortcut("b");
		public static const C : PXKeyShortcut = PXKeyShortcut.buildShortcut("c");
		public static const D : PXKeyShortcut = PXKeyShortcut.buildShortcut("d");
		public static const E : PXKeyShortcut = PXKeyShortcut.buildShortcut("e");
		public static const F : PXKeyShortcut = PXKeyShortcut.buildShortcut("f");
		public static const G : PXKeyShortcut = PXKeyShortcut.buildShortcut("g");
		public static const H : PXKeyShortcut = PXKeyShortcut.buildShortcut("h");
		public static const I : PXKeyShortcut = PXKeyShortcut.buildShortcut("i");
		public static const J : PXKeyShortcut = PXKeyShortcut.buildShortcut("j");
		public static const K : PXKeyShortcut = PXKeyShortcut.buildShortcut("k");
		public static const L : PXKeyShortcut = PXKeyShortcut.buildShortcut("l");
		public static const M : PXKeyShortcut = PXKeyShortcut.buildShortcut("m");
		public static const N : PXKeyShortcut = PXKeyShortcut.buildShortcut("n");
		public static const O : PXKeyShortcut = PXKeyShortcut.buildShortcut("o");
		public static const P : PXKeyShortcut = PXKeyShortcut.buildShortcut("p");
		public static const Q : PXKeyShortcut = PXKeyShortcut.buildShortcut("q");
		public static const R : PXKeyShortcut = PXKeyShortcut.buildShortcut("r");
		public static const S : PXKeyShortcut = PXKeyShortcut.buildShortcut("s");
		public static const T : PXKeyShortcut = PXKeyShortcut.buildShortcut("t");
		public static const U : PXKeyShortcut = PXKeyShortcut.buildShortcut("u");
		public static const V : PXKeyShortcut = PXKeyShortcut.buildShortcut("v");
		public static const W : PXKeyShortcut = PXKeyShortcut.buildShortcut("w");
		public static const X : PXKeyShortcut = PXKeyShortcut.buildShortcut("x");
		public static const Y : PXKeyShortcut = PXKeyShortcut.buildShortcut("y");
		public static const Z : PXKeyShortcut = PXKeyShortcut.buildShortcut("z");

		public static const NUM_0 : PXKeyShortcut = PXKeyShortcut.buildShortcut("0");
		public static const NUM_1 : PXKeyShortcut = PXKeyShortcut.buildShortcut("1");
		public static const NUM_2 : PXKeyShortcut = PXKeyShortcut.buildShortcut("2");
		public static const NUM_3 : PXKeyShortcut = PXKeyShortcut.buildShortcut("3");
		public static const NUM_4 : PXKeyShortcut = PXKeyShortcut.buildShortcut("4");
		public static const NUM_5 : PXKeyShortcut = PXKeyShortcut.buildShortcut("5");
		public static const NUM_6 : PXKeyShortcut = PXKeyShortcut.buildShortcut("6");
		public static const NUM_7 : PXKeyShortcut = PXKeyShortcut.buildShortcut("7");
		public static const NUM_8 : PXKeyShortcut = PXKeyShortcut.buildShortcut("8");
		public static const NUM_9 : PXKeyShortcut = PXKeyShortcut.buildShortcut("9");

		public static const PAD0 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD0");
		public static const PAD1 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD1");
		public static const PAD2 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD2");
		public static const PAD3 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD3");
		public static const PAD4 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD4");
		public static const PAD5 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD5");
		public static const PAD6 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD6");
		public static const PAD7 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD7");
		public static const PAD8 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD8");
		public static const PAD9 : PXKeyShortcut = PXKeyShortcut.buildShortcut("PAD9");

		public static const MULTIPLY : PXKeyShortcut = PXKeyShortcut.buildShortcut("Multiply");
		public static const ADD : PXKeyShortcut = PXKeyShortcut.buildShortcut("Pad +");
		public static const SUBSTRACT : PXKeyShortcut = PXKeyShortcut.buildShortcut("Pad -");
		public static const DECIMAL : PXKeyShortcut = PXKeyShortcut.buildShortcut("Decimal");
		public static const DIVIDE : PXKeyShortcut = PXKeyShortcut.buildShortcut("Divide");

		public static const F1 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F1");
		public static const F2 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F2");
		public static const F3 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F3");
		public static const F4 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F4");
		public static const F5 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F5");
		public static const F6 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F6");
		public static const F7 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F7");
		public static const F8 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F8");
		public static const F9 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F9");
		public static const F10 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F10");
		public static const F11 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F11");
		public static const F12 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F12");
		public static const F13 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F13");
		public static const F14 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F14");
		public static const F15 : PXKeyShortcut = PXKeyShortcut.buildShortcut("F15");

		public static const BACKSPACE : PXKeyShortcut = PXKeyShortcut.buildShortcut("Backspace");
		public static const CAPSLOCK : PXKeyShortcut = PXKeyShortcut.buildShortcut("Capslock");
		public static const CONTROL : PXKeyShortcut = PXKeyShortcut.buildShortcut("Ctrl");
		public static const COMMAND : PXKeyShortcut = PXKeyShortcut.buildShortcut("Cmd");
		public static const DELETEKEY : PXKeyShortcut = PXKeyShortcut.buildShortcut("Delete");
		public static const DOWN : PXKeyShortcut = PXKeyShortcut.buildShortcut("KeyDown");
		public static const END : PXKeyShortcut = PXKeyShortcut.buildShortcut("KeyEnd");
		public static const ENTER : PXKeyShortcut = PXKeyShortcut.buildShortcut("KeyEnter");
		public static const ESCAPE : PXKeyShortcut = PXKeyShortcut.buildShortcut("Esc");
		public static const HOME : PXKeyShortcut = PXKeyShortcut.buildShortcut("Home");
		public static const INSERT : PXKeyShortcut = PXKeyShortcut.buildShortcut("Insert");
		public static const LEFT : PXKeyShortcut = PXKeyShortcut.buildShortcut("Left");
		public static const PGDN : PXKeyShortcut = PXKeyShortcut.buildShortcut("PageDown");
		public static const PGUP : PXKeyShortcut = PXKeyShortcut.buildShortcut("PageUp");
		public static const RIGHT : PXKeyShortcut = PXKeyShortcut.buildShortcut("Right");
		public static const SHIFT : PXKeyShortcut = PXKeyShortcut.buildShortcut("Shift");
		public static const SPACE : PXKeyShortcut = PXKeyShortcut.buildShortcut("Space");
		public static const TAB : PXKeyShortcut = PXKeyShortcut.buildShortcut("Tab");
		public static const UP : PXKeyShortcut = PXKeyShortcut.buildShortcut("KeyUp");
		
		
		//--------------------------------------------------------------------
		// Private implementations
		//--------------------------------------------------------------------
		
		/**
		 * @private
		 */
		function PXKey()
		{
		}
	}
}